


    ;- Memory  window
      attrib_bag["TITLE"] = "Memory"
      attrib_bag["HASFRAME"] = FALSE
      attrib_bag["ORIGINCOL"] = 55
      attrib_bag["ORIGINROW"] = 36
      attrib_bag["WIDTH"] = 25
      attrib_bag["HEIGHT"] = 13
      attrib_bag["STYLE"] = 32  ;black on green
      WINDOW CREATE ATTRIBUTES attrib_bag TO g_handle_bag["MEMORY"]
      PAINTCANVAS ATTRIBUTE 32 ALL


      WINDOW SELECT g_handle_bag["MEMORY"]
      WINDOW SELECT g_handle_bag["MEMORY"]
      WINDOW CLOSE

                  g_handle_bag["MEMORY"],
                  tr_trigger_bag,
                  tr_procs_bag,
                  tr_memory_bag,
                  g_cycle_n,
                  tr_varmem_a


   ;-- memory status
   IF g_cycle_n <> cyclenumber_n OR
      basetrigger_a = "ARRIVEFIELD" OR
      rval_n = 1  THEN
      IF RECORDSTATUS("New") THEN
         rnew_a = "TRUE"
      ELSE
         rnew_a = "FALSE"
      ENDIF
      IF RECORDSTATUS("Modified") THEN
         rmod_a = "TRUE"
      ELSE
         rmod_a = "FALSE"
      ENDIF
      IF RECORDSTATUS("Locked") THEN
         rlck_a = "TRUE"
      ELSE
         rlck_a = "FALSE"
      ENDIF
      WINDOW LIST TO w_r
      winnum_a = STRVAL(ARRAYSIZE(w_r))
      SETCANVAS g_handle_bag["MEMORY"]
      STYLE ATTRIBUTE  32
      CLEAR
      PAINTCANVAS ATTRIBUTE 32 ALL
      WINDOW SELECT g_handle_bag["MEMORY"]
      WINDOW SCROLL g_handle_bag["MEMORY"] TO 0,0
      SETMARGIN OFF
      STYLE ATTRIBUTE 14
      @0,0 ?? FORMAT("W25,AC","* * INFO STATUS * *")
      @1,0
      STYLE ATTRIBUTE  32
      SETMARGIN 1
       ? "MEMLEFT()   = "+STRVAL(memleft())
       ? "RMEMLEFT()  = "+STRVAL(rmemleft())
       ? "RSTATUS-NEW = "+rnew_a
       ? "RSTATUS-MOD = "+rmod_a
       ? "RSTATUS-LCK = "+rlck_a
       ? "LINKTYPE    = "+LINKTYPE()
       ? "TABLE       = "+TABLE()
       ? "VAR-MEM     = "+tr_varmem_a
       ? "#IMAGES     = "+STRVAL(NIMAGES())
       ? "#WINDOWS    = "+winnum_a
   ENDIF


      "~V~ars Status"  :"Current Savevars":"save",

         CASE choice_a = "save" :
            TracTunerSaveVarList_n()


; ============================================================
; 09-10-93
; Complete variable list
; ------------------------------------------------------------
PROC TracTunerSaveVarList_n()
   PRIVATE Procname.a,
           tr_savevar_bag,
           v_n,
           save_a,
           buttonval_v
   Procname.a = "TracTunerSaveVarList_n"
   IF NOT ISASSIGNED(TracTuner_l) THEN
      BEEP BEEP RETURN 1
   ENDIF
   ECHO OFF
   QuickMsg_u("Loading Savevar setup...")
   SaveWorspace_u()
   IF SYSMODE() = "CoEdit" THEN DO_IT! ENDIF
   IF ISFILE("savevars.sc") THEN
      RUN NOREFRESH "RENAME SAVEVARS.SC SAVEVARS.OLD >nul"
   ENDIF
   SAVEVARS ALL
   ;--make sure it is written to disk and file is closed
   z = FILESIZE("savevars.sc")
   ;--- import this into a table
   MENU "TEIAT" SELECT "savevars.sc"
                SELECT "savevars"
   IF MENUCHOICE() = "Cancel" THEN SELECT "Replace" ENDIF
   ;--update var memory estimate
   tr_varmem_a = STRVAL(NRECORDS("savevars"))

   DYNARRAY tr_savevar_bag[]
   v_n = 0
   IF UPPER(TABLE()) <> "SAVEVARS" THEN
      VIEW "savevars"
   ENDIF
   MOVETO [Text]
   SCAN
      SWITCH
         CASE MATCH([],"Dynarray tr_..[]") : LOOP
         CASE MATCH([],"Array tr_..[..]..") : LOOP
         CASE MATCH([],";.."): LOOP  ;comment
         CASE ISBLANK([]): LOOP  ;blank
         OTHERWISE:
            v_n = v_n + 1
            tr_savevar_bag[STRVAL(v_n)] = []
      ENDSWITCH
   ENDSCAN
   CLEARIMAGE
   QuickMsg_u("")
  ; PaintPAL_Generated_Code_Begin(455766953)

  SHOWDIALOG "Savevars"
     @2,2 HEIGHT 46 WIDTH 75

     ; PaintPAL_Frame_Begin
     FRAME DOUBLE FROM 0,1 TO 40,71
     PAINTCANVAS ATTRIBUTE 127 0,1,0,71
     PAINTCANVAS ATTRIBUTE 112 40,1,40,71
     PAINTCANVAS ATTRIBUTE 127 0,1,40,1
     PAINTCANVAS ATTRIBUTE 112 0,71,40,71
     ; PaintPAL_Frame_End

     PICKDYNARRAY @1,2 HEIGHT 39 WIDTH 68
        tr_savevar_bag
        TAG "save"
        TO save_a

     PUSHBUTTON @42,29 WIDTH 15
        "Return"
        CANCEL
        VALUE "return"
        TAG "return"
        TO buttonval_v
  ENDDIALOG

  ; PaintPAL_Generated_Code_End(455766953)
   IF ISFILE("savevars.old") THEN
       RUN NOREFRESH "RENAME SAVEVARS.OLD SAVEVARS.SC >nul"
   ENDIF
   RestoreWorkspace_u()
   RETURN 1
ENDPROC

